window.Gleam.initSearch([{"doc":"glimmer","title":"glimmer","content":"# Glimmer\n\n[![Package Version](https://img.shields.io/hexpm/v/glimmer)](https://hex.pm/packages/glimmer)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/glimmer/)\n\nA concurrency library for Gleam!\n\n# NOTE: This is currently broken. It is accepting feedback and assistance, but several functions are unusable.\n(The tests are passing, to give you a sense of which parts of it work :)\n\n## Quick start\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n\n## Installation\n\nThis package can be added to your Gleam project:\n\n```sh\ngleam add glimmer\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/glimmer&gt;.\n","url":"index.html"},{"doc":"glimmer/dream","title":"Dream","content":"pub opaque type Dream(a)\n The type of dreams that return values.\n\nSynonyms:\nglimmer/dream.Dream\nglimmer/dream Dream","url":"glimmer/dream.html#Dream"},{"doc":"glimmer/dream","title":"DreamError","content":"pub type DreamError {\n  ExitError(reason: Dynamic)\n  TimeoutError\n}\n The errors dreams may produce, \n checkable with `try_await` and `try_await_with_timeout`.\nExitError(reason: Dynamic)\n\n\nTimeoutError\n\n\nSynonyms:\nglimmer/dream.DreamError\nglimmer/dream DreamError","url":"glimmer/dream.html#DreamError"},{"doc":"glimmer/dream","title":"async","content":"pub fn async(foo: fn() -&gt; a) -&gt; Dream(a)\n Spawn a dream that returns a value.\n The value is retrieved with one of the `await` functions.\n If the dream crashes then the owning process\n also crashes, \nSynonyms:\nglimmer/dream.async\nglimmer/dream async","url":"glimmer/dream.html#async"},{"doc":"glimmer/dream","title":"await","content":"pub fn await(dream: Dream(a)) -&gt; a\n A version of `try_await` that assumes there wasn&#39;t an error,\n crashing if there was. If a timeout is needed see `await_with_timeout`.\nSynonyms:\nglimmer/dream.await\nglimmer/dream await","url":"glimmer/dream.html#await"},{"doc":"glimmer/dream","title":"await_with_timeout","content":"pub fn await_with_timeout(dream: Dream(a), timeout: Int) -&gt; a\n A version of `try_await_with_timeout` that assumes there wasn&#39;t an error,\n crashing if there was.\nSynonyms:\nglimmer/dream.await_with_timeout\nglimmer/dream await_with_timeout","url":"glimmer/dream.html#await_with_timeout"},{"doc":"glimmer/dream","title":"spawn","content":"pub fn spawn(foo: fn() -&gt; Nil) -&gt; Nil\n Spawn a dream that won&#39;t return a value.\n (It simply does work and side-effects.)\n If the dream crashes then the owning process\n also crashes.\nSynonyms:\nglimmer/dream.spawn\nglimmer/dream spawn","url":"glimmer/dream.html#spawn"},{"doc":"glimmer/dream","title":"spawn_unlinked","content":"pub fn spawn_unlinked(foo: fn() -&gt; Nil) -&gt; Nil\n Spawn a dream that won&#39;t return a value.\n (It simply does work and side-effects.)\n If the dream crashes then the owning process\n *doesn&#39;t* crash. The crash is completely silent.\nSynonyms:\nglimmer/dream.spawn_unlinked\nglimmer/dream spawn_unlinked","url":"glimmer/dream.html#spawn_unlinked"},{"doc":"glimmer/dream","title":"try_await","content":"pub fn try_await(dream: Dream(a)) -&gt; Result(a, DreamError)\n A version of `try_await_with_timeout` that waits indefinitely,\n instead of until a timeout runs out.\nSynonyms:\nglimmer/dream.try_await\nglimmer/dream try_await","url":"glimmer/dream.html#try_await"},{"doc":"glimmer/dream","title":"try_await_with_timeout","content":"pub fn try_await_with_timeout(dream: Dream(a), timeout: Int) -&gt; Result(\n  a,\n  DreamError,\n)\n Get the value of a dream, waiting until it&#39;s done working,\n the time is up, or it crashes. Returns a value that lets you\n distinguish between these three cases.\nSynonyms:\nglimmer/dream.try_await_with_timeout\nglimmer/dream try_await_with_timeout","url":"glimmer/dream.html#try_await_with_timeout"},{"doc":"glimmer/dream","title":"glimmer/dream","content":" `glimmer/dream` is a shallow wrapper around `gleam/otp/task` for promise-like workloads.\n Dreams are conceptually coroutines that may or may not return a value. They are simply a block of\n code executed in parallel, with some functionality to get the return value if needed.\n `spawn` creates a dream with no return value (hence no dream is really created, and `spawn` returns Nil).\n `spawn_unlinked` creates a dream that may crash *without crashing the owning process*, which doesn&#39;t\n return a value either (so again, no actual dream in the implementation). `async` creates a dream that\n does return a value, so if it crashes then the owning process crashes too, and `async` returns a dream\n value you can use for one of this library&#39;s various `await` functions for getting the return value later on.","url":"glimmer/dream.html"},{"doc":"glimmer/stream","title":"PipeMessage","content":"pub opaque type PipeMessage(a)\n the types of messages used within Glimmer, for Streams.\n\nSynonyms:\nglimmer/stream.PipeMessage\nglimmer/stream PipeMessage","url":"glimmer/stream.html#PipeMessage"},{"doc":"glimmer/stream","title":"Stream","content":"pub type Stream(a) {\n  Stream(process.Subject(PipeMessage(a)))\n}\n A concurrent stream of values.\n This isn&#39;t a datastructure per se, it&#39;s all lazy.\nStream(process.Subject(PipeMessage(a)))\n\n\nSynonyms:\nglimmer/stream.Stream\nglimmer/stream Stream","url":"glimmer/stream.html#Stream"},{"doc":"glimmer/stream","title":"close","content":"pub fn close(s: Stream(a)) -&gt; Nil\n Indicate that no more values will be sent in the stream.\n This is optional but useful if the stream is intended to model some finite datastructure,\n which many of these functions expect.\n This is an imperative, side-effectful procedure.\n See `with` for some ergonomics with `close`.\nSynonyms:\nglimmer/stream.close\nglimmer/stream close","url":"glimmer/stream.html#close"},{"doc":"glimmer/stream","title":"collect","content":"pub fn collect(s: Stream(a)) -&gt; List(a)\n Represent a stream as a list.\n This blocks until there&#39;s an indication that the stream is over.\n (See `close`.) Also consider using `to_iterator` if you can.\nSynonyms:\nglimmer/stream.collect\nglimmer/stream collect","url":"glimmer/stream.html#collect"},{"doc":"glimmer/stream","title":"each","content":"pub fn each(stream: Stream(a), f: fn(a) -&gt; Nil) -&gt; Nil\n Perform a side-effect for each element in the stream, consuming it.\n This effect can include writing to another stream,\n so the elements aren&#39;t necessarily gone. For example:\n \n use &lt;- with(output_stream)\n use i &lt;- each(input_stream)\n output_stream |&gt; write(i * 2)\n \nSynonyms:\nglimmer/stream.each\nglimmer/stream each","url":"glimmer/stream.html#each"},{"doc":"glimmer/stream","title":"filter","content":"pub fn filter(input: Stream(a), p: fn(a) -&gt; Bool) -&gt; Stream(a)\n Filter elements out of a stream concurrently\n (as opposed to, say, calling `collect` and then using `list.filter`).\n Internally there is imperative dark magic but this presents\n a pure functional interface (if `p` is pure).\n This makes it great for pipes. For example,\n \n [1, 2, 3]\n |&gt; from_list\n |&gt; filter(fn(n) { n % 2 == 0 })\n |&gt; collect()\n |&gt; io.debug() // prints [1, 3]\n \nSynonyms:\nglimmer/stream.filter\nglimmer/stream filter","url":"glimmer/stream.html#filter"},{"doc":"glimmer/stream","title":"from_list","content":"pub fn from_list(l: List(a)) -&gt; Stream(a)\n Construct a stream from a list.\nSynonyms:\nglimmer/stream.from_list\nglimmer/stream from_list","url":"glimmer/stream.html#from_list"},{"doc":"glimmer/stream","title":"generator","content":"pub fn generator(g: fn(fn(a) -&gt; Nil, fn() -&gt; Nil) -&gt; Nil) -&gt; Stream(\n  a,\n)\n Generate a stream. For example:\n \n fn count_down(n, yield, stop) {\n   case n == 0 {\n     True -&gt; stop()\n     False -&gt; {\n       yield(n)\n       count_down(n - 1, yield, stop)\n     }\n   }\n }\n ...\n generator(count_down(5, _, _))\n |&gt; collect()\n |&gt; io.debug() // prints [5, 4, 3, 2, 1]\n \nSynonyms:\nglimmer/stream.generator\nglimmer/stream generator","url":"glimmer/stream.html#generator"},{"doc":"glimmer/stream","title":"map","content":"pub fn map(input: Stream(a), f: fn(a) -&gt; b) -&gt; Stream(b)\n Map a function over a stream concurrently \n (as opposed to, say, calling `collect` and then using `list.map`).\n Internally there is imperative dark magic but this presents\n a pure functional interface (if `f` is pure). \n This makes it great for pipes. For example,\n \n [1, 2, 3]\n |&gt; from_list()\n |&gt; map(fn(n) { n + 1 })\n |&gt; map(fn(n) { n * 2 })\n |&gt; collect()\n |&gt; io.debug() // prints [4, 6, 8]\n \nSynonyms:\nglimmer/stream.map\nglimmer/stream map","url":"glimmer/stream.html#map"},{"doc":"glimmer/stream","title":"new","content":"pub fn new() -&gt; Stream(a)\n Construct a stream.\nSynonyms:\nglimmer/stream.new\nglimmer/stream new","url":"glimmer/stream.html#new"},{"doc":"glimmer/stream","title":"next","content":"pub fn next(s: Stream(a)) -&gt; Result(a, Nil)\n Get the next value from the stream. \n Wait if there isn&#39;t one yet.\nSynonyms:\nglimmer/stream.next\nglimmer/stream next","url":"glimmer/stream.html#next"},{"doc":"glimmer/stream","title":"next_with_timeout","content":"pub fn next_with_timeout(s: Stream(a), timeout: Int) -&gt; Result(\n  a,\n  Nil,\n)\n Get the next value from the stream.\n Wait if it isn&#39;t there yet, giving up if the timeout runs out.\nSynonyms:\nglimmer/stream.next_with_timeout\nglimmer/stream next_with_timeout","url":"glimmer/stream.html#next_with_timeout"},{"doc":"glimmer/stream","title":"reduce","content":"pub fn reduce(input: Stream(a), start: b, f: fn(a, b) -&gt; b) -&gt; b\n Reduce (or fold) a stream to a value.\n This is concurrent in the sense that reduction steps begin before\n the last value arrives, and may happen in parallel.\n However, the function won&#39;t return until all values are received, of course.\n Internally there is imperative dark magic but this presents\n a pure functional interface (if `f` is pure).\n This makes it great for pipes. For example,\n \n [1, 2, 3]\n |&gt; from_list\n |&gt; reduce(0, fn(a, b) { a + b })\n |&gt; io.debug() // prints 6\n \nSynonyms:\nglimmer/stream.reduce\nglimmer/stream reduce","url":"glimmer/stream.html#reduce"},{"doc":"glimmer/stream","title":"to_iterator","content":"pub fn to_iterator(s: Stream(a)) -&gt; Iterator(a)\n Represent a stream as a Gleam iterator.\n This is a more faithful representation than a list,\n and indeed concurrency is preserved by the produced\n iterator!\nSynonyms:\nglimmer/stream.to_iterator\nglimmer/stream to_iterator","url":"glimmer/stream.html#to_iterator"},{"doc":"glimmer/stream","title":"try_each","content":"pub fn try_each(stream: Stream(a), f: fn(a) -&gt; Result(Nil, b)) -&gt; Result(\n  Nil,\n  b,\n)\n Iterate through the elements in the stream until done or `Error`.\n Perform some computation each time.\n For example:\n \n use i &lt;- try_each(input_stream)\n case i &lt; 0 {\n   True -&gt; Error(&quot;found a negative!&quot;)\n   False -&gt; Ok(Nil)\n }\n \nSynonyms:\nglimmer/stream.try_each\nglimmer/stream try_each","url":"glimmer/stream.html#try_each"},{"doc":"glimmer/stream","title":"with","content":"pub fn with(stream: Stream(a), f: fn() -&gt; b) -&gt; b\n Use a stream and then `close` it. \n This is intended for `use` syntax, for example:\n \n use &lt;- with(output_stream)\n write(out, &quot;hi&quot;)\n \nSynonyms:\nglimmer/stream.with\nglimmer/stream with","url":"glimmer/stream.html#with"},{"doc":"glimmer/stream","title":"write","content":"pub fn write(s: Stream(a), value: a) -&gt; Nil\n Write a value to a stream.\n This is an imperative, side-effectful procedure.\nSynonyms:\nglimmer/stream.write\nglimmer/stream write","url":"glimmer/stream.html#write"},{"doc":"glimmer/stream","title":"glimmer/stream","content":" `glimmer/stream` introduces an abstraction over `gleam/erlang/process`, called a Stream.\n The goal of streams are to make parallelism free and easy by having it appear sequential.\n There are both functional and imperative (effectful) functions in this library.\n The imperative functions are most useful for getting a stream started:\n the options for filling up a fresh stream are basically just `write` which is imperative and\n `from_list` which is functional, and `write` will make more sense for many situations.\n Once a stream is going, and you just need to process it, then the functional functions\n (`map`, `filter`, `reduce`, `collect`, `to_iterator`) can be very ergonomic and sensible.\n Note: streams masquerade as lists, but they aren&#39;t datastructures. Reading from them consumes the items,\n which the functional functions get around by saving results in a new stream or datastructure.\n If you want something like array-indexing then you&#39;ll need to convert the stream into an \n actual datastructure, perhaps with `collect`, and likely lose any concurrency benefits.","url":"glimmer/stream.html"}]);